<?php

namespace Teknisa\OPL\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource;
use Teknisa\OPL\Controller\TeknisaCrud;
use Teknisa\OPL\Services\Dfs48000SaidaDoOperadorLogisticoService;
    
class Dfs48000SaidaDoOperadorLogisticoController extends \Teknisa\Libs\Controller\CrudNext {
    
    protected $saidaDoOperadorLogisticoService;
    protected $dataSourceName = 'dfs48000_saida_notafiscal';
    protected $entityManager;
    protected $environment;
    protected $crudService;
    
    public function __construct($crudService, $parameterBag,Dfs48000SaidaDoOperadorLogisticoService $dfs48000SaidaDoOperadorLogisticoService) {
        $this->dfs48000SaidaDoOperadorLogisticoService = $dfs48000SaidaDoOperadorLogisticoService;
    }
    
    public function gerarSaida(DTO\Request $request, DTO\Response $response) {
        $nextRequest = parent::buildRequest($request);
        //var_dump(get_class_methods($request['rowData']));die;
        //var_dump($request);die;
        //var_dump($request);die;
        $dataSet = $nextRequest->getDataSet();
        //var_dump($dataSet);die;
        //$row = $nextRequest->getDataSet()[0];
        //var_dump($row);die;
        $notasFiscais    = $dataSet->getRows()[0];
        //var_dump($notasFiscais);die;
        $dadosSaida      = $dataSet->getRows()[1];
        var_dump($dadosSaida);die;
        //$dadosAdicionais = $nextRequest->getDataSet()->getRows()[2];
        
        
        $this->dfs48000SaidaDoOperadorLogisticoService->gerarSaida($notasFiscais, $dadosSaida, $dadosAdicionais);
        
        $erros = $this->dfs48000SaidaDoOperadorLogisticoService->getErros();
        $numNotasSucesso = $this->dfs48000SaidaDoOperadorLogisticoService->getQtNotasSucesso();
        $response->addDataset(new DataSource\DataSet('errosSaida', $erros));
        if($numNotasSucesso != 0) {
            $response->addMessage(new Response\Message($numNotasSucesso));
        }
        else {
            $response->addMessage(new Response\Message("Não foi possível realizar a saída das notas fiscais selecionadas."));
        }
    
    }


}
