<?php

require_once 'base/LoteEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 */
class LoteEntity extends LoteEntityBase
{


    /**
     * Insere um novo lote.
     *
     * @param integer $filial     Cdigo da filial.
     * @param integer $nrlote     Nmero do Lote.
     * @param integer $sublote    Nmero do Sublote.
     * @param integer $produto    Cdigo do Produto.
     * @param string  $status     Status do Lote.
     * @param date    $dtvalidade Data de validade do produto.
     * @param integer $nrorg      Nmero da Organizao.
     * @param integer $operador   Cdigo do Operador.
     *
     * @return boolean
     */
    public static function incluiLote(
        $filial, $nrlote, $sublote, $produto,
        $status, date $dtvalidade, $nrorg, $operador){

        try {
            $db=TkDbAdapter::getWorkConnection();

            $now = date('d/m/y');

            $obj = new self();
            $obj->setCdfilial($filial);
            $obj->setNrloteestq($nrlote);
            $obj->setNrsublote($sublote);
            $obj->setCdproduto($produto);
            $obj->setIdstatlote($status);
            $obj->setDtentrlote($now);
            $obj->setDtvalilote($dtvalidade);
            $obj->setNrorg($nrorg);
            $obj->setDtinclusao($now);
            $obj->setDtultatu($now);
            $obj->setNrorginclusao($nrorg);
            $obj->setCdoperinclusao($operador);
            $obj->setNrorgultatu($nrorg);
            $obj->setCdoperultatu($operador);
            $obj->persist();

            return true;
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }

    }//end incluiLote()


    /**
     * Retorno registros de um determinado lote.
     *
     * @param integer $nrorg   Nmero da Organizao.
     * @param integer $filial  Cdigo da Filial.
     * @param integer $produto Cdigo do Produto.
     * @param integer $nrlote  Nmero do Lote.
     *
     * @return false|objeto
     */
    public function retornaLote($nrorg, $filial, $produto, $nrlote){
        $retorno = Lote::consultaLote($nrorg, $filial, $produto, $nrlote);
        return $retorno;

    }//end retornaLote()


    /**
     * Atualiza a Data de Validade de um determinado lote.
     *
     * @param integer $filimovi   Cdigo da Filial de Movimento.
     * @param integer $nrorg      Nmero da Organizao.
     * @param date    $dtvalidade Data de validade do produto.
     * @param integer $cdproduto  Cdigo do produto.
     * @param integer $nrlote     Nmero do Lote.
     *
     * @return boolean
     */
    public static function alteraValidadeLote(
        $filimovi, $nrorg, date $dtvalidade, $cdproduto, $nrlote){

        $db = TkDbAdapter::getWorkConnection();

        $query = $db->createQuery()
            ->update("LOTE")
            ->set("DTVALILOTE", "'$dtvalidade'")
            ->addWhere("NRORG   = "."'$nrorg'")
            ->addWhere("CDFILIAL  = "."'$filimovi'")
            ->addWhere("CDPRODUTO  = "."'$cdproduto'")
            ->addWhere("NRLOTEESTQ  = "."'$nrlote'");
        $rows = $db->execute($query);
        if ($rows){
            return true;
        } else {
            return false;
        }

    }//end alteraValidadeLote()


}//end class

