import {
  Http, IEventParam, Metadata, IDictionary,
} from '@zeedhi/core';
import {
  AlertService, Form, IGridEvent, Modal, ModalService, StateType, LoadingService,
} from '@zeedhi/common';
import { TekGrid } from '@zeedhi/teknisa-components-common';

export class Dfs48000SaidaDoOperadorLogisticoController {
  private gerarDocumentoModal!: Modal;

  private modalErrosGerarSaida!: Modal;

  public readOnlySubGrup: StateType = true;

  public readOnlyRota: StateType = true;

  public readOnlyDestPed: StateType = true;

  public readOnlyLote: StateType = true;

  public filterValueCDFILIOPELOG: any = {};

  public filterValueCDROTATRANS: Array<any> = [];

  public filterValueCDSUBGRPPROD: Array<any> = [];

  public filterValueCDFILIALDEST: Array<any> = [];

  public filterValueCDLOTENVIOL: Array<any> = [];

  public filterValuePEDOLEXTR: Array<any> = [];

  public filterValueVERIFICACNPJ: any = null;

  public filterValueDTENTREGA: any = {};

  public filterValueSTATUS: Array<any> = [];

  public filterValueDATAENT: any = 0;

  public filterGridFormulario: any = {};

  public filterGridFormularioProduto: any = {};

  public filterGridLancamentoGerado: any = {};

  public filterValueNRINSJUREMPR: any = {};

  public filterValueIDUTILCONSSOLIOL: any = {};

  public filterValueFILCLIE: any = {};

  public periodDisabled: StateType = true;

  public swtDisabled: StateType = false;

  public adqEmpresa: any = {};

  public filterGridForm: any = {};

  public filterValueCDTIPOOPER: any;
  
  public showTabOtherGrids = false;
  
  public isLoadingDefault = false;
  
  public orderDescription = '';

  public async createGerarDocumenoModal() {
    this.gerarDocumentoModal = await ModalService.createFromJson('pages/dfs48000/dfs4800Saida_do_opl_gerar_documento', true);
  }

  public destroyGerarDocumentoModal() {
    this.gerarDocumentoModal?.destroy();
  }

  public onChangeSwitchRota({ component }: IEventParam<any>) {
    if (this.readOnlyRota) {
      this.filterValueCDROTATRANS = [];
      
      component.parent.children.forEach((child: { name: any; value: any; }) => {
        if (child.name === 'gridSaidasOPL-filter-AND-CONTAINS-CDROTATRANSFILTER-0') {
          child.value = [];
        }
      });
    }
  }

  public onChangeSwitchSubGrup({ component }: IEventParam<any>) {
    if (this.readOnlySubGrup) {
      this.filterValueCDSUBGRPPROD = [];
      
      component.parent.children.forEach((child: { name: any; value: any; }) => {
        if (child.name === 'gridSaidasOPL-filter-AND-CONTAINS-CDSUBGRPRODFILTER-0') {
          child.value = [];
        }
      });
    }
  }

  public onChangeSwitchDestPed({ component }: IEventParam<any>) {
    if (this.readOnlyDestPed) {
      this.filterValueCDFILIALDEST = [];
      
      component.parent.children.forEach((child: { name: any; value: any; }) => {
        if (child.name === 'gridSaidasOPL-filter-AND-CONTAINS-DSFILIALFILTER-0') {
          child.value = 'T';
        }
      });
    }
  }

  public onChangeSwitchLote({ component }: IEventParam<any>) {
    if (this.readOnlyLote) {
      this.filterValueCDLOTENVIOL = [];
      
      component.parent.children.forEach((child: { name: any; value: any; }) => {
        if (child.name === 'gridSaidasOPL-filter-AND-CONTAINS-CDLOTENVITOLFILTER-0') {
          child.value = [];
        }
      });
    }
  }

  public onChangeLote() {
    this.swtDisabled = true;
  }

  public onChangeFieldFilialOL({ component }: any) {
    this.filterValueCDFILIOPELOG = component.value;
    
    const fielddest = component.parent.childrenInstances.filter((field: any) => field.name.includes('DSFILIAL'))[0];
    
    fielddest.datasource.clearFilter();
    
    fielddest.datasource.addFilter('P_CDFILIOPELOG', component.value !== null ? component.value.CDFILIAL : null);
    
    fielddest.datasource.removeOrder('P_CDFILIOPELOG');
    
    fielddest.datasource.data = [];
    
    fielddest.datasource.get();
  }

  public onChangeFieldRotaOL({ component }: any) {
    this.filterValueCDROTATRANS = component.value;
  }

  public onChangeFieldSubgrupoOL({ component }: any) {
    this.filterValueCDSUBGRPPROD = component.value;
  }

  public onChangeFieldFilialDestOL({ component }: any) {
    this.filterValueCDFILIALDEST = component.value;
  }

  public onChangeFieldLoteOL({ component }: any) {
    this.filterValueCDLOTENVIOL = component.value;
  }

  public onChangeFieldStatusPedidoOL({ component }: any) {
    this.filterValuePEDOLEXTR = component.value;
  }

  public onChangeFieldDTEntOL({ component }: any) {
    this.filterValueDATAENT = component.value;
  }

  public onChangeFieldStatusPedOL({ component }: any) {
    this.filterValueSTATUS = component.value;
  }

  public onChangeFieldInscrDestOL({ component }: any) {
    this.filterValueVERIFICACNPJ = component.value;
  }

  public onChangeFieldDataEntOL({ component }: any) {
    this.filterValueDTENTREGA = component.value;
  }

  public onChangeFieldTipoOperOL({ component }: any) {
    const form = Metadata.getInstance<Form>('formModalGerarDocumentoAdd');
    const fieldSerie = form.getChildInstance<any>('CDSERIE');
    
    if (component.value !== null) {
      fieldSerie.datasource.filter.P_CDTIPOOPER = component.value.CDTIPOOPER;
      
      fieldSerie.readonly = false;
    } else {
      fieldSerie.datasource.filter.P_CDTIPOOPER = '';
      
      fieldSerie.readonly = true;
    }
    
    fieldSerie.datasource.get();
    
    this.filterValueCDTIPOOPER = component.value;
  }
  
  public onChangeTransportadora({ component }: any) {
    const form = Metadata.getInstance<Form>('formModalGerarDocumentoAdd');
    const fieldPlaca = form.getChildInstance<any>('NRPLACA');
    
    if (component.value !== null) {
      fieldPlaca.datasource.filter.P_NRINSJURTRAN = component.value.NRINSJURTRAN;
      fieldPlaca.datasource.filter.P_IDTPIJURTRAN = component.value.IDTPIJURTRAN;
      
      fieldPlaca.readonly = false;
    } else {
      fieldPlaca.datasource.filter.P_NRINSJURTRAN = '';
      fieldPlaca.datasource.filter.P_IDTPIJURTRAN = '';
      
      fieldPlaca.readonly = true;
    }
    
    fieldPlaca.datasource.get();
  }

  public onFilterSaidaOpen({ component }: any) {
    LoadingService.show('Carregando...');
    
    const filterButton = document.getElementById('gridSaidasOPL_filterButton');
    
    filterButton?.click();
    
    setTimeout(() => {
      const campoRota = component.getFilterInputs('ROTASWITCH')[0];
      const campoSubgrupo = component.getFilterInputs('SUBGRUPRODSWITCH')[0];
      const campoDestino = component.getFilterInputs('DESTPEDSWITCH')[0];
      const campoLote = component.getFilterInputs('LOTESWITCH')[0];
      const campoStatusPed = component.getFilterInputs('PEDOLEXTR')[0].getChildInstance('PEDOLEXTR');
      const campoStatus = component.getFilterInputs('STATUSFILTER')[0].getChildInstance('STATUSFILTER');
      const campoDataCons = component.getFilterInputs('DATAENT')[0];
      const campoCnpj = component.getFilterInputs('VERIFICACNPJ')[0];
      
      campoRota.value = true;
      campoSubgrupo.value = true;
      campoDestino.value = true;
      campoLote.value = true;
      campoStatusPed.value = [
        {
          id: 'S',
          value: 'Extra',
        },
        {
          id: 'N',
          value: 'Não Extra',
        },
      ];
      campoStatus.value = [
        {
          id: 0,
          value: 'Vazio (Sem NF de Saída/Sem retorno do OL)',
        },
        {
          value: 'Amarelo (Sem NF de Saída/Com retorno do OL)',
          id: 1,
        },
        {
          value: 'Verde (Com NF de Saída Gerada)',
          id: 2,
        },
      ];
      campoDataCons.setValue(
        {
          name: 'Data de Entrega',
          value: 0,
        },
      );
      campoCnpj.setValue(
        {
          name: 'Desconsidera',
          value: null,
        },
      );
      
      LoadingService.hide();
    }, 200);
  }

  public formater(array: Array<any>) {
    return array.length !== 0 ? String('_').concat(array.join('_').concat(String('_'))) : 'T';
  }

  public async getInfo(datasourcefilter: string) {
    return Http.get(datasourcefilter);
  }

  public async onFilterload() {
    const grid = Metadata.getInstance<any>('gridSaidasOPL');
    const arrayCDFILIDEST = typeof grid.datasource.dynamicFilter.DSFILIALFILTER !== 'undefined' ? grid.datasource.dynamicFilter.DSFILIALFILTER[0].value.map((f: any) => f.CDFILIAL) : [];
    const arrayCDSUBGRPPROD = typeof grid.datasource.dynamicFilter.CDSUBGRPRODFILTER !== 'undefined' ? grid.datasource.dynamicFilter.CDSUBGRPRODFILTER[0].value.map((f: any) => f.CDSUBGRPROD) : [];
    const arrayCDROTATRANS = typeof grid.datasource.dynamicFilter.CDROTATRANSFILTER !== 'undefined' ? grid.datasource.dynamicFilter.CDROTATRANSFILTER[0].value.map((f: any) => f.CDROTATRANS) : [];
    const arrayCDLOTENVIOL = typeof grid.datasource.dynamicFilter.CDLOTENVITOLFILTER !== 'undefined' ? grid.datasource.dynamicFilter.CDLOTENVITOLFILTER[0].value.map((f: any) => f.CDLOTENVITOL) : [];
    const arrayPEDOLEXTR = this.filterValuePEDOLEXTR.length === 2 ? 'T' : this.filterValuePEDOLEXTR.map((f: any) => f.id);
    const arraySTATUS = this.filterValueSTATUS.map((f: any) => f.id);
    const nrinsjDatasource = 'crudN/dfs48000adqEmpresa?in=CDFILIOPELOG&CDFILIOPELOG='.concat(this.filterValueCDFILIOPELOG.CDFILIAL);
    const clienteExtDatasource = 'crudN/dfs48000adqclienteExt?in=CDFILIOPELOG&CDFILIOPELOG='.concat(this.filterValueCDFILIOPELOG.CDFILIAL);
    const utilConsOLDatasource = 'crudN/dfs48000adqParaSupri?in=CDFILIOPELOG&CDFILIOPELOG='.concat(this.filterValueCDFILIOPELOG.CDFILIAL);

    this.filterValueNRINSJUREMPR = await this.getInfo(nrinsjDatasource);
    this.filterValueFILCLIE = await this.getInfo(clienteExtDatasource);
    this.filterValueIDUTILCONSSOLIOL = await this.getInfo(utilConsOLDatasource);

    const filterFilial = {
      P_CDLOTENVIOL: this.formater(arrayCDLOTENVIOL),
      P_PEDOLEXTR: arrayPEDOLEXTR === 'T' ? 'T' : this.formater(arrayPEDOLEXTR),
      P_NRSJUREMPR: this.filterValueNRINSJUREMPR.data.data[0].NRINSJUREMPR,
      P_DATAENT: this.filterValueDATAENT.value,
      P_DTENTREGA: this.filterValueDTENTREGA,
      P_FILOPELOG: grid.datasource.dynamicFilter.CDFILIOPELOG[0].value.CDFILIAL,
      P_CDFILIAL: this.formater(arrayCDFILIDEST),
      P_ROTA: arrayCDROTATRANS.length > 0 ? this.formater(arrayCDROTATRANS) : null,
      P_FILCLIE: this.filterValueFILCLIE.data.data[0].CDCLIENTEEXT !== '0' ? 'L' : 'C',
      P_SUBGRUPO: this.formater(arrayCDSUBGRPPROD),
      P_VERIFICACNPJ: this.filterValueVERIFICACNPJ.value,
      P_CDCLIENTE: this.formater(arrayCDFILIDEST) === 'T' ? 'T' : null,
      P_STATUS: this.formater(arraySTATUS),
      P_IDUTILCONSSOLIOL: this.filterValueIDUTILCONSSOLIOL.data.data[0].IDUTILCONSSOLIOL,
    };

    grid.datasource.filter = filterFilial;
    grid.datasource.get();
  }

  public async loadGridFormulario(params: any) {
    const gridFormulario = Metadata.getInstance<TekGrid>('gridFormulario');
    const filterGridFormulario = {
      P_CDFILLANC: params.row.CDFILLANC,
      P_FILOPELOG: this.filterValueCDFILIOPELOG.CDFILIAL,
      P_NRAUTOFORN: params.row.NRAUTOFORN,
      P_SUBGRUPO: 'T',
      P_DATAENT: this.filterValueDATAENT.value,
      P_DTENTREGA: this.filterValueDTENTREGA,
      P_DTPROC: null,
      P_PEDOLEXTR: 'T',
      P_CDLOTENVIOL: 'T',
      P_IDBAIXAOLSA: 'T',
      P_IDUTILCONSSOLIOL: this.filterValueIDUTILCONSSOLIOL.data.data[0].IDUTILCONSSOLIOL,
      P_FILDEST: params.row.CDFILIAL,
    };
    
    gridFormulario.datasource.filter = filterGridFormulario;
    gridFormulario.datasource.get();
  }

  public loadGridFormularioProduto({ component }: any) {
    component.datasource.route = 'crudN/dfs48000gridSaidaOplFormularioProduto';

    component.datasource.filter = this.filterGridFormularioProduto;
    component.datasource.get();
  }

  public loadGridLancamentoGerado(params: any) {
    const gridLancamento = Metadata.getInstance<TekGrid>('gridLancamento');
    const filterGridLancamentoGerado = {
      P_CDFILDEST: params.row.CDFILIAL,
      P_DTENTREGA: this.filterValueDTENTREGA,
      P_CDFILLANC: params.row.CDFILLANC,
      P_NRAUTOFORN: params.row.NRAUTOFORN,
      P_DATAENT: this.filterValueDATAENT.value,
      P_CDLOTENVIOL: 'T',
      P_SUBGRUPO: 'T',
    };

    gridLancamento.datasource.filter = filterGridLancamentoGerado;
    gridLancamento.datasource.get();
  }

  public onChangeCdfiliOl({ component }: IEventParam<any>) {
    const fieldValueDestino = component.parent.getElementById('CDFILIALDEST');

    fieldValueDestino.datasource.filter.P_CDFILIOPELOG = component.value.CDFILIAL;

    fieldValueDestino.datasource.get();
  }

  public abrirModalGerarDocumento() {
    const grid = Metadata.getInstance<IGridEvent>('gridSaidasOPL');
    const selectedRows = grid.selectedRows;
    
    LoadingService.show('Carregando...');
    
    if (selectedRows.length > 0) {
      this.gerarDocumentoModal.show();
      
      setTimeout(() => {
        const form = Metadata.getInstance<Form>('formModalGerarDocumentoAdd');
        const fieldTipoOper = form.getChildInstance<any>('CDTIPOOPER');
        const fieldTransprt = form.getChildInstance<any>('NMRAZSOCTRAN');
        const fieldSerie = form.getChildInstance<any>('CDSERIE');
        const unidades: any[] = [];
        
        selectedRows.forEach((row: any) => {
          unidades.push(row.CDFILIAL);
        });
        
        fieldTransprt.datasource.filter.P_CDFILIALOL = this.filterValueCDFILIOPELOG.CDFILIAL;
        
        fieldSerie.datasource.filter.P_CDFILIALOL = this.filterValueCDFILIOPELOG.CDFILIAL;
        
        const unStr = unidades.join('_');
        const unidadesString = String('_').concat(String(unStr).concat(String('_')));
        
        Http.get(`crudN/dfs48000_clienteext?in=P_CDFILIOPELOG&P_CDFILIOPELOG=${this.filterValueCDFILIOPELOG.CDFILIAL}`).then((response) => {
          Http.get(`crudN/dfs48000_tipooper_param?in=P_CDFILIOPELOG&in=P_CDFILIAL&P_CDFILIOPELOG=${this.filterValueCDFILIOPELOG.CDFILIAL}&P_CDFILIAL=${unidadesString}`).then((response1) => {
            if (response1.data.data.length > 0) {
              fieldTipoOper.setValue(response1.data.data[0].CDTIPOOPERSAID);
              
              fieldTipoOper.readonly = true;
              
              fieldTipoOper.datasource.get().then(() => {
                LoadingService.hide();
              });
            } else {
              if (response.data.data.length > 0) {
                let cont = 0;
                
                response.data.data.forEach((row: any) => {
                  if (row.CDCLIENTEEXT !== null) {
                    cont += 1;
                  }
                });
                
                if (cont === 0) {
                  fieldTipoOper.datasource.filter.P_CDTIPOOPER = '02';
                  fieldTipoOper.datasource.filter.P_IDORIGDESTOP = 'L';
                  
                  fieldTipoOper.datasource.get().then(() => {
                    LoadingService.hide();
                  });
                } else {
                  fieldTipoOper.datasource.filter.P_CDTIPOOPER = '';
                  fieldTipoOper.datasource.filter.P_IDORIGDESTOP = 'C';
                  
                  fieldTipoOper.datasource.get().then(() => {
                    LoadingService.hide();
                  });
                }
              } else {
                fieldTipoOper.datasource.filter.P_CDTIPOOPER = '02';
                fieldTipoOper.datasource.filter.P_IDORIGDESTOP = 'L';
                
                fieldTipoOper.datasource.get().then(() => {
                  LoadingService.hide();
                });
              }
              fieldTipoOper.readonly = false;
            }
          });
        });
      }, 1000);
    } else {
      LoadingService.hide();
      
      AlertService.show({
        top: true,
        right: true,
        timeout: 1000,
        name: 'notCheckedAltert',
        text: 'Deve ser marcado pelo menos uma unidade para a geração de saída.',
        color: 'error',
      });
    }
  }

  public fecharModalGerarDocumento() {
    this.gerarDocumentoModal.hide();
  }

  public selectRowsFormulario() {
    const gridProduto = Metadata.getInstance<IGridEvent>('gridSaidasOPL');
    const arrayGrid = gridProduto.datasource.currentRowValue;
    return arrayGrid;
  }

  public selectRowslancGerado() {
    const gridNotaFiscal = Metadata.getInstance<IGridEvent>('grid-formulario-OPL');
    const arrayGrid = gridNotaFiscal.datasource.currentRowValue;
    return arrayGrid;
  }

  public async salvarModalGerarDocumento() {
    const grid = Metadata.getInstance<TekGrid>('gridSaidasOPL');
    const rows = grid.selectedRows;
    const form = Metadata.getInstance<Form>('formModalGerarDocumentoAdd');
    // const dadosadic = Metadata
    const valid = form.validate();
    // const fieldCDFILIAL = Metadata.getInstance<Select>('CDFILIOPELOG')
    const rowData = {
      // CDTIPOOPER: form.value.CDTIPOOPER,
      // DATA: form.value.DATA,
      // NMRAZSOCTRAN: form.value.NMRAZSOCTRAN,
      // FRETE: form.value.FRETE,
      // NRPLACA: form.value.NRPLACA,
      // SGUFVEICULO: form.value.SGUFVEICULO,
      notas: rows,
      dadosGeradcao: form,
      // DADOSADIC: dadosadic,
    };
    
    if (!valid) {
      AlertService.show({
        top: true,
        right: true,
        timeout: 2000,
        name: 'invalidoAltert',
        text: 'Preencha todos os campos obrigatórios!',
        color: 'error',
      });
    } else {
      form.submit();
      await Http.post('/gerarSaida', { requestType: 'DataSet', rowData }).then((response) => {
        if (response.data.dataset.data[0] === 'error') {
          this.openModalErrosGerarSaida(response.data.dataset.data[1]);
        } else if (response.data.dataset.data.P_ERROS === 'N') {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'successAlert',
            text: 'Processo concluído com sucesso!',
            color: 'success',
          });

          this.fecharModalGerarDocumento();
        } else {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'errorAlert',
            text: 'Não foi possível concluir o processo!<br>Não há dados!',
            color: 'error',
          });
        }
      });
    }
  }

  public async openModalErrosGerarSaida(erros: any[]) {
    if (!this.modalErrosGerarSaida) {
      this.modalErrosGerarSaida = ModalService.create({
        name: 'modalErrosGerarSaida',
        fullscreen: false,
        virtualScroll: false,
        children: [
          {
            name: 'headerContainer',
            component: 'ZdContainer',
            children: [
              {
                name: 'headerFixed',
                component: 'ZdHeader',
                color: 'transparent',
                padless: true,
                elevation: 0,
                centerSlot: [
                  {
                    name: 'titleText',
                    component: 'ZdText',
                    text: 'Erros ao gerar saída',
                    cssClass: 'zd-theme-font-title',
                  },
                ],
                rightSlot: [
                  {
                    name: 'closeModalButton',
                    component: 'ZdModalCloseButton',
                    small: true,
                    modalName: 'modalErrosGerarSaida',
                  },
                ],
              },
              {
                name: 'general-grid',
                component: 'ZdGrid',
                gridHeight: '420px',
                virtualScroll: true,
                dense: false,
                showFooter: true,
                showHeader: true,
                columns: [
                  {
                    name: 'NRLINHA',
                    label: 'Linha',
                    sortable: false,
                  },
                  {
                    name: 'POSICAO',
                    label: 'Item Posição',
                    maxWidth: '100px',
                  },
                  {
                    name: 'TAMANHO',
                    label: 'Tamanho',
                    maxWidth: '75px',
                  },
                  {
                    name: 'VALOR',
                    label: 'Valor',
                    maxWidth: '170px',
                    overflow: 'wrap',
                  },
                  {
                    name: 'MENSERRO',
                    label: 'Descrição do Erro',
                    overflow: 'wrap',
                  },
                ],
                datasource: {
                  data: erros,
                  limit: 10,
                  lazyLoad: false,
                },
              },
            ],
          },
        ],
      });
    }
    this.modalErrosGerarSaida.show();
  }
  
  public closeModal() {
    this.modalErrosGerarSaida.hide();
  }
  
  public getConditionalCssClassIdStatus(row: IDictionary<any>) {
    if (row.IDSTATUS === '1') {
      return {
        cssClass: 'yellow-row',
      };
    }
    if (row.IDSTATUS === '2') {
      return {
        cssClass: 'green-row',
      };
    }
    return {};
  }
  
  public changeValueOfLote({ row }: IDictionary<any>) {
    if (row.CDLOTENVITOL === 'T') {
      row.CDLOTENVITOL = 'Sem Lote';
    }
  }
  
  get isVisibleGridSaidasOPL() {
    return !this.showTabOtherGrids;
  }
  
  public cellClick(params: any) {
    this.showTabOtherGrids = true;
    
    this.isLoadingDefault = false;
    
    this.orderDescription = String(params.row.NRAUTOFORN).concat(String(' - Unidade: ').concat(params.row.DSFILIAL));
    
    this.loadGridFormulario(params);
    this.loadGridLancamentoGerado(params);
  }
  
  public clickBackToPrincipalGrid() {
    this.showTabOtherGrids = false;
  }
}
